/*
 * Project: irond
 * Package: src.de.fhhannover.inform.ifmap.view.component
 * File:    ToolbarPanel.java
 *
 * Copyright (C) 2010 Fachhochschule Hannover
 * Ricklinger Stadtweg 118, 30459 Hannover, Germany 
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an AS IS BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhhannover.inform.ifmap.view.component;

import javax.swing.JPanel;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import java.awt.BorderLayout;
import javax.swing.JToggleButton;
import javax.swing.SwingConstants;

public class ToolbarPanel extends JPanel {
	private static final long serialVersionUID = 2814752100004120354L;
	public JButton buttonConnections;
	public JToggleButton buttonConnect;
	public JButton buttonPublisher;
	public JButton buttonSubscribe;
	public JToggleButton buttonQuickSubscribe;
	
	private JLabel labelIron;
	private JLabel lblNewLabel;	
	
	public ToolbarPanel() {
		setLayout(new BorderLayout(5, 0));
		
		JPanel panelButtons = new JPanel();
		add(panelButtons, BorderLayout.WEST);
		
		buttonConnections = new JButton("Connections");		
		buttonConnections.setFocusable(false);
		buttonConnections.setIcon(new ImageIcon(getClass().getClassLoader().getResource("connections.png")));
		panelButtons.add(buttonConnections);
		
		buttonConnect = new JToggleButton("Connect");
		buttonConnect.setFocusable(false);
		buttonConnect.setIcon(new ImageIcon(getClass().getClassLoader().getResource("con1.png")));
		panelButtons.add(buttonConnect);
		
		buttonPublisher = new JButton("Publisher");
		buttonPublisher.setFocusable(false);
		buttonPublisher.setIcon(new ImageIcon(getClass().getClassLoader().getResource("user_info.png")));
		panelButtons.add(buttonPublisher);
		
		buttonSubscribe = new JButton("Subscribe");
		buttonSubscribe.setFocusable(false);
		buttonSubscribe.setIcon(new ImageIcon(getClass().getClassLoader().getResource("rss.png")));
		panelButtons.add(buttonSubscribe);
		
		buttonQuickSubscribe = new JToggleButton("Quick Subscribe");
		buttonQuickSubscribe.setFocusable(false);
		buttonQuickSubscribe.setIcon(new ImageIcon(getClass().getClassLoader().getResource("ball_blue.png")));
		panelButtons.add(buttonQuickSubscribe);
		
		JPanel panelLinks = new JPanel();
		add(panelLinks, BorderLayout.EAST);
		panelLinks.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
		
		JLabel labelTrust = new JLabel("");
		labelTrust.setHorizontalAlignment(SwingConstants.RIGHT);
		labelTrust.setIcon(new ImageIcon(getClass().getClassLoader().getResource("logo_tnc.png")));
		panelLinks.add(labelTrust);
		
		labelIron = new JLabel("");
		labelIron.setIcon(new ImageIcon(getClass().getClassLoader().getResource("logo_iron.png")));
		labelIron.setHorizontalAlignment(SwingConstants.RIGHT);
		panelLinks.add(labelIron);
		
		lblNewLabel = new JLabel("");
		lblNewLabel.setHorizontalAlignment(SwingConstants.RIGHT);
		lblNewLabel.setIcon(new ImageIcon(getClass().getClassLoader().getResource("esukom.png")));
		panelLinks.add(lblNewLabel);
	}
}
